package mine;

public class Ticket {
	
	private String summary;
	private int id;
	private Ticket parentTicket;
	
	public Ticket(String summary, int id) {
		this.summary = summary;
		this.id = id;
	}	

	/* This method is used to check what kind 
	   of parent class the object can have	 */
	public String checkParentStatus() throws NoSuchMethodException, SecurityException {
				
		Class c = this.getClass();
		String parentStatus = "can't have parents\n";
			
		IsChildOf cAnno = (IsChildOf) c.getAnnotation(IsChildOf.class);
		String parentClass = cAnno.TicketClass();
		
		if(parentClass.equals("Incident")) {
			parentStatus = "can have incidents as parents\n"; 
			return parentStatus;
		} else if (parentClass.equals("ChangeRequest")) {
			parentStatus = "can have change requests as parents\n"; 
			return parentStatus;
		}		
		return parentStatus;		
	}	
	
	/* This method is used to compare class types 
	   and annotaions properties of the relating objects */
	public boolean selectParent(Ticket t) throws NoSuchMethodException, SecurityException {
		
		Class parentClass = t.getClass();
		Class childClass = this.getClass();
				
		IsParentOf pAnno = (IsParentOf) parentClass.getAnnotation(IsParentOf.class);
		String childStatus = pAnno.TicketClass();
		
		IsChildOf cAnno = (IsChildOf) childClass.getAnnotation(IsChildOf.class);
		String parentStatus = cAnno.TicketClass();
						
		String childClassName = this.getClass().getSimpleName();
		String parentClassName = t.getClass().getSimpleName();
		
		if(parentStatus.equals(parentClassName) && childStatus.equals(childClassName)) {
			System.out.println("STATUS: OK! RELATED: " + childClassName + 
					" and " + parentClassName + "\n");
			return true;
		} else {
			System.out.println("STATUS: WARNING! Can't relate " + childClassName 
					+ " and " + parentClassName + "\nINFO: " + childClassName + " " 
					+ this.checkParentStatus());
		}	return false;		
	}	
	
	public void setParent(Ticket t) throws NoSuchMethodException, SecurityException {
		
		if(this.selectParent(t)) {
			this.parentTicket = t;
		}		
	}		
	
	public String getSummary() {
		return summary;
	}

	public void setSummary(String summary) {
		this.summary = summary;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}
	
}
