package src;

import java.util.*;

public class PlayList {
	
	public static void main (String[] args) {
			
		List<String> l1 = new ArrayList<String>();
		List<String> l2 = new ArrayList<String>();
		
		l1.add("First1");
		l1.add("First2");
		l1.add("First3");
		
		l2.add("Second1");
		l2.add("Second2");
		l2.add("Second3");
		
//		l1.addAll(l2);
		
		List<String> l3 = new ArrayList<String>(l1);
		l3.addAll(l2);
				
		l3.set(1, "setSecond");
		
		if(l3.set(2, "setThird") == "First3")	// the set and remove operations return the old value that is being overwritten or removed
			System.out.println("changed 3rd element");
		
		
//		swap(l2, 2, 0);
		shuffle(l2, new Random());
		
		for(Iterator it = l2.iterator(); it.hasNext();) {
			System.out.println(it.next());
		}
		
		System.out.println(l3.get(1));
		
		for(ListIterator<String> lit = l1.listIterator(l1.size()); lit.hasPrevious();) {	// standard idiom for iterating backward through a list
			System.out.println(lit.previous());
		}
		
		
		replace(l1, "First3", "First3[replaced]");	// replace all occurrences of one specified value with another
		for(ListIterator<String> lit = l1.listIterator(); lit.hasNext();) {
			System.out.println(lit.next());
		}
		
		replaceB(l2, "Second1", l1);
		for(ListIterator<String> lit = l2.listIterator(); lit.hasNext();) {
			System.out.println(lit.next());
		}
		
		System.out.println(l2.subList(0, 3));
		l2.subList(2, 3).clear();	// removes a range of elements
		System.out.println(l2.subList(0, 3));	// removed range replaced with the next values
	}
	
	
	public static <String> void swap(List<String> a, int i, int j) {		
		String tmp = a.get(i);
		a.set(i, a.get(j));
		a.set(j, tmp);
	}
	
	public static void shuffle(List<?> list, Random rnd) {
		for(int i = list.size(); i > 0; i--)
			swap(list, i - 1, rnd.nextInt(i));		
	}

	public static <String> void replace (List<String> list, String val, String newVal) {
		
		for (ListIterator<String> it = list.listIterator(); it.hasNext(); ) {
			
			if(val == null ? it.next() == null : val.equals(it.next())) {
				it.set(newVal);
			}				
		}		
	}
	
	/* polymorphic algorithm to replace all occurrences of a specified value 
	 * with the sequence of values contained in the specified list */
	public static <String> void replaceB (List<String> list, String val, List<? extends String> newVals) { 
		
		for (ListIterator<String> it = list.listIterator(); it.hasNext(); ) {
			
			if(val == null ? it.next() == null : val.equals(it.next())) {
				it.remove();
				for (String e : newVals)
					it.add(e);
			}				
		}		
	}
	
}