package src;

import java.util.*;

public class PlayMap {

	public static void main(String[] args) {
		
		Map<String, Integer> map = new HashMap<String, Integer>(); // power of an interface-based framework: TreeMap for alphabetical order, LinkedHashMap in the order the elements first appear 
		map.put("Salzburg", 330000);
		map.put("Edinburgh", 800000);
		map.put("Bremen", 750000);
		System.out.println(map);
		
		Map<String, Integer> map2 = new HashMap<String, Integer>(map);	// copy map
		System.out.println(map2);
		
		Map<String, Integer> map3 = new HashMap<String, Integer>();
		map3.putAll(map2);
		System.out.println(map3);
		map3.clear();
		System.out.println(map3);
		map3.put("Uppsala", 450000);
		
		Map<String, Integer> map4 = newAttributeMap(map, map3);
		System.out.println(map4);
				

		// iterating
		
		for (String s : map4.keySet())	// keys iterating
			System.out.println(s);
		
		for (Iterator it = map4.values().iterator(); it.hasNext(); ) { // values iterating
			System.out.println(it.next());
		}
		
		for (Map.Entry<String, Integer> me : map4.entrySet()) // key-value pairs iterating
			System.out.println("City: " + me.getKey() + "\nInhabitans: " + me.getValue());	
		
		setInhab(map4, "Salzburg", 250000);
		setInhab(map4, "Bremen", 333666);
		System.out.println(map4);
		
		
		if (map.entrySet().containsAll(map2.entrySet()))
			System.out.println("maps are equal");
		
	}
	
	
	static <K, V> Map<K, V> newAttributeMap (Map<K, V> defaults, Map<K, V> overrides) {
		
		Map<K, V> result = new HashMap<K, V>(defaults);
		result.putAll(overrides);
		return result;
	}
	
	
	static void setInhab(Map<String, Integer> map, String city, int ppl) {
		
		for (Map.Entry<String, Integer> me : map.entrySet())
			if (me.getKey() == city)
				me.setValue(ppl);
	}

}
