package src;

import java.util.*;

public class PlayMap2 {

	public static void main(String[] args) {
		
		Set<String> req = new HashSet<String>();
		Set<String> perm = new HashSet<String>();
		
		req.add("Helsinki");
		req.add("Stockholm");
		req.add("Oslo");
		
		perm.add("Tallinn");
		perm.add("Kobenhavn");
		perm.add("Helsinki");
		perm.add("Stockholm");
		perm.add("Oslo");
		
		Map<String, Integer> cities = new HashMap<String, Integer>();
		cities.put("Moscow", 12000000);
		cities.put("Helsinki", 560000);
		cities.put("Stockholm", 560000);
		cities.put("Oslo", 540000);
		
		validate(cities, req, perm);	
		
		
		Map<String, Integer> map1 = new HashMap<String, Integer>();
		map1.put("First", 1);
		map1.put("Second", 2);
		map1.put("Third", 3);

		Map<String, Integer> map2 = new HashMap<String, Integer>();
		map2.put("First", 1);
		map2.put("Second2", 2);
		map2.put("Third2", 3);
		
		map1.entrySet().removeAll(map2.entrySet());
				
		for(Iterator it = map1.entrySet().iterator(); it.hasNext(); ) {
			System.out.println(it.next());
		}
	}
	
	
	static <K, V> boolean validate(Map<K, V> attrMap, Set<K> requiredAttrs, Set<K>permittedAttrs) {
		
		boolean valid = true;
		Set<K> attrs = attrMap.keySet();
		
		if(!attrs.containsAll(requiredAttrs)) {
			Set<K> missing = new HashSet<K>(requiredAttrs);
			missing.removeAll(attrs);
			System.out.println("Missing attributes: " + missing);
			valid = false;
		}
		
		if(!permittedAttrs.containsAll(attrs)) {
			Set<K> illegal = new HashSet<K>(attrs);
			illegal.removeAll(permittedAttrs);
			System.out.println("Illegal attributes: " + illegal);
			valid = false;
		}
		
		return valid;
	}

}
