package src;

import java.util.*;

public class PlaySet {

	public static void main(String[] args) {
		
		Collection<String> c = new HashSet(); 
		c.add("First");
		c.add("Second");
		c.add("Second");
		c.add("Third");
		
		Collection<String> noDups = new HashSet<String>(c);	// creating a Set (which, by definition, cannot contain a duplicate), initially containing all the elements in c
		Collection<String> noDupsOrdered = new LinkedHashSet<String>(c); // preserves the order of the original collection while removing duplicate element
		
		Collection<Integer> c2 = new HashSet();
		c2.add(1);
		c2.add(2);
		c2.add(2);
		c2.add(3);
		
		Collection<String> removedDups = removeDups(c);
		
		
		for (Iterator it = removedDups.iterator(); it.hasNext();) {
			System.out.println(it.next());
		}

		Collection<Integer> c3 = new HashSet();
		c3.add(3);
		c3.add(4);
		c3.add(5);
		c3.add(6);
		
		Set<Integer> union = new HashSet<Integer>(c2);
		union.addAll(c3);
		
		Set<Integer> intersection = new HashSet<Integer>(c2);
		intersection.retainAll(c3);
		
		Set<Integer> difference = new HashSet<Integer>(c2);
		difference.removeAll(c3);
		
		Set<Integer> symmetricDiff = new HashSet<Integer>(c2);
		symmetricDiff.addAll(c3);
		Set<Integer> tmp = new HashSet<Integer>(c2);
		tmp.retainAll(c3);
		symmetricDiff.removeAll(tmp);
		
		
		for (Iterator it = intersection.iterator(); it.hasNext();) {
			System.out.println(it.next());
		}		
		
	}
	
	
	public static <E> Set<E> removeDups(Collection<E> c) {
		return new LinkedHashSet<E>(c);
	}
}
