package src;

import java.util.*;


public class PlayConvenienceImpl {

	public static void main(String[] args) {
		
		/* 1. List View of an Array, Arrays.asList() */
		String[] cities = new String[10];
		cities[0] = "Hamina";
		cities[1] = "Porvoo";
		cities[2] = "Kotka";
		for(int i = 0; i < cities.length; i++) {
			System.out.print(cities[i] + ", ");
		}
		System.out.println();		
		
		List<String> citiesList = Arrays.asList(cities);
		System.out.println(citiesList);
		
		// citiesList.add("Turku"); // Exception: the size of the collection is that of the array and cannot be changed.
		
		// If you need a fixed-size List, it's more efficient than any general-purpose List implementation
		List<String> citiesFixed = Arrays.asList(new String[12]);
		
		
		/* 2. Immutable Multiple-Copy List, Collections.nCopies() */
		String s = "Helsinki";
		String s2 = "Naantali";
		List<String> citiesCopies = new ArrayList<String>(Collections.nCopies(9, s)); // ArrayList initially consists of 9 elements
		System.out.println(citiesCopies);
		
		citiesCopies.addAll(3, Collections.nCopies(3, s2)); // growing an existing List, adding 3 copies of s2 to the list from index 3
		System.out.println(citiesCopies);
		
		
		/* 3. Immutable Singleton Set */
		citiesCopies.removeAll(Collections.singleton(s2)); // Removes all occurrences of a specified element from a Collection
		System.out.println(citiesCopies);

	}

}
