package src;

import java.util.*;

public class PlayWrapperImpl {

	public static void main(String[] args) {
		
		List<String> listSync = Collections.synchronizedList(new ArrayList<String>()); // The synchronization wrappers add automatic synchronization (thread-safety) to an arbitrary collection
		
		List<String> listUnmod = new ArrayList<String>();
		listUnmod.add("First");
		listUnmod.add("Second");
		listUnmod.add("First");
		System.out.println(listUnmod);
		
		/* Unmodifiable wrappers take functionality away. 
		 * In particular, they take away the ability to modify the collection 
		 * by intercepting all the operations that would modify the collection 
		 * and throwing an UnsupportedOperationException
		 */
		listUnmod = Collections.unmodifiableList(listUnmod); 
		listUnmod.set(2, "Third");
		System.out.println(listUnmod);
		
	}

}
