package src;

import java.util.*;

public class PlayAlgorithms {

	public static void main(String[] args) {

		/* SORTING */
		List<String> list = new ArrayList<String>();
		list.add("Wupertal");
		list.add("Bonn");
		list.add("Bielefeld");
		list.add("London");
		list.add("Lisabon");
		list.add("Pisa");
		Collections.sort(list, new Comparator<String>() {
		    public int compare(String o1, String o2) {
		        return o2.length() - o1.length();
		    }});
		
		System.out.println(list);
		
		Collections.sort(list, new Comparator<String>() {	// sorts elements end with "n"
			public int compare(String s1, String s2) {
				int i1 = 0;
				if (s1.endsWith("n"))
					i1 = 1;
				return 0 - i1;
			}
		});
		System.out.println(list);
		
		/* SHUFFLING */
		Collections.shuffle(list);
		System.out.println(list);
		
		/* DATA MAINPULATION */
		Collections.reverse(list);
		System.out.println(list);
		
		List<String> list2 = new ArrayList<String>(Collections.nCopies(6, "blank"));
		Collections.copy(list2, list);
		System.out.println(list2);
		
		Collections.fill(list, "Cologne");
		System.out.println(list);
		
		Collections.swap(list2, 5, 0);
		System.out.println(list2);
		
		Collections.addAll(list2, "Custom", "Custom");
		System.out.println(list2);
		
		/* SEARCHING */
		Collections.sort(list2);
		int pos = Collections.binarySearch(list2, "Bonn");
		System.out.println(list2);
		System.out.println(pos);
		
		/* COMPOSITION */
		String freq = "Custom";
		System.out.println("String '" + freq + "' occurs " + Collections.frequency(list2, freq) + " times");
		
		if (Collections.disjoint(list, list2) == true)
			System.out.println("Collections contain no elements in common");
		else
			System.out.println("Collections contain elements in common");
		
		/* EXTREME VALS */
		System.out.println(Collections.max(list2));
		System.out.println(Collections.min(list2));				
		
	}

}
