package com.odissue.hibernate.cache;


import java.util.*;

import org.hibernate.Criteria;
import org.hibernate.HibernateException;
import org.hibernate.Query;
import org.hibernate.SQLQuery;
import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.Transaction;
import org.hibernate.cfg.Configuration;
import org.hibernate.criterion.Criterion;
import org.hibernate.criterion.LogicalExpression;
import org.hibernate.criterion.Order;
import org.hibernate.criterion.Projections;
import org.hibernate.criterion.Restrictions;

import com.odissue.hibernate.cache.WorkOrder;
import com.odissue.hibernate.cache.Ticket;

public class OdissueTest {
	
	private static SessionFactory sf;
	
	public static void main (String[] args) {
		sf = new Configuration().configure().buildSessionFactory();
		Session session = sf.openSession();
		
		String sql = "SELECT summary FROM ticket";
		SQLQuery query = session.createSQLQuery(sql);
		query.setResultTransformer(Criteria.ALIAS_TO_ENTITY_MAP);
		List results = query.list();
		System.out.println(results.get(0));
		
		String sql2 = "SELECT * FROM TICKET";
		SQLQuery query2 = session.createSQLQuery(sql2);
		query2.addEntity(Ticket.class);
		List results2 = query2.list();
		
		showResults(results2, "Results #2: ");
		
		String sql3 = "SELECT * FROM ticket WHERE id = :t_id";
		SQLQuery query3 = session.createSQLQuery(sql3);
		query3.addEntity(Ticket.class);
		query3.setCacheable(true);
		query3.setParameter("t_id", 90);
		List results3 = query3.list();
		
		showResults(results3, "Results #3: ");
	}
	
	public static void showResults(List results, String msg) {
		System.out.println("\n" + msg);
		
		for (int i = 0; i < results.size(); i++) {
			Ticket tkt = (Ticket)results.get(i);
			System.out.println("ID: " + tkt.getId());
			System.out.println("Summary: " + tkt.getSummary());
			System.out.println("Requester: " + tkt.getRequester());
			
			System.out.println("Child WO: " + tkt.getWorkorder().getSummary()); 
		}
	}

}
