package com.odissue.hibernate.collections.map;


import java.util.*;

import org.hibernate.HibernateException;
import org.hibernate.SQLQuery;
import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.Transaction;
import org.hibernate.cfg.Configuration;

import com.odissue.hibernate.collections.map.OdissueTest;
import com.odissue.hibernate.collections.map.Ticket;
import com.odissue.hibernate.collections.map.WorkOrder;


public class OdissueTest {
	
	private static SessionFactory sf;
	
	public static void main (String[] args) {
		sf = new Configuration().configure().buildSessionFactory();
		Session session = sf.openSession();
		
		HashMap children = new HashMap();
		children.put("New", new WorkOrder("FIRST"));
		children.put("In Progress", new WorkOrder("SECOND"));
		children.put("Completed", new WorkOrder("THIRD"));
		
		OdissueTest ot = new OdissueTest();
		ot.addTicket("PARENT", "VF", children);
		
		ot.listTickets();
		
		
	}
	
	public void listTickets() {
		Session session = sf.openSession();
//		Transaction tx = null;
//		try {
//			tx = session.beginTransaction();
			List tickets = session.createQuery("FROM Ticket").list();
				for (Iterator it = tickets.iterator(); it.hasNext();) {
					Ticket tkt = (Ticket)it.next();
					System.out.println("\nID: " + tkt.getId());
					System.out.println("Summary: " + tkt.getSummary());
					System.out.println("Requester: " + tkt.getRequester());
					
					Map wos = tkt.getWorkorders();
					System.out.println("------------\nChild WOs:");
					System.out.println("New: " + (((WorkOrder)wos.get("New")).getSummary()));
					System.out.println("In Progress: " + (((WorkOrder)wos.get("In Progress")).getSummary()));
					System.out.println("Completed: " + (((WorkOrder)wos.get("Completed")).getSummary()));
				}
//			tx.commit();
//		} catch (HibernateException he) {
//			if (tx!=null) tx.rollback();		
//			he.printStackTrace();
//		} finally {
//			session.close();
//		}
	}
	
	public Integer addTicket(String summary, String requester, HashMap children) {
		Session session = sf.openSession();
		Integer ticketID = null;
		Transaction tx = null;
		try {
			tx = session.beginTransaction();
			Ticket tkt = new Ticket(summary, requester);
			tkt.setWorkorders(children);
			
			ticketID = (Integer)session.save(tkt);
			tx.commit();
		} catch (HibernateException he) {
			if (tx!=null) tx.rollback();
				he.printStackTrace();
		} finally {
			session.close();
		}
		return ticketID;
	}
	
	public void updateTicket(Integer TicketID, String summary) {
		Session session = sf.openSession();
		Transaction tx = null;
		try {
			tx = session.beginTransaction();
				Ticket tkt = (Ticket)session.get(Ticket.class, TicketID);
				tkt.setSummary(summary);
				session.update(tkt);
			tx.commit();
		} catch (HibernateException he) {
			if(tx!=null) tx.rollback();
			he.printStackTrace();
		} finally {
			session.close();
		}	
	}
	
	public void deleteTicket(Integer TicketID) {
		Session session = sf.openSession();
		Transaction tx = null;
		try {
			tx =  session.beginTransaction();
				Ticket tkt = (Ticket)session.get(Ticket.class, TicketID);
				session.delete(tkt);
				tx.commit();
		} catch (HibernateException he) {
			if(tx!=null) tx.rollback();
			he.printStackTrace();
		} finally {
			session.close();
		}
	}
}
