package com.odissue.hibernate.collections.set;


import java.util.*;

import org.hibernate.HibernateException;
import org.hibernate.SQLQuery;
import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.Transaction;
import org.hibernate.cfg.Configuration;

import com.odissue.hibernate.collections.set.OdissueTest;
import com.odissue.hibernate.collections.set.Ticket;
import com.odissue.hibernate.collections.set.WorkOrder;


public class OdissueTest {
	
	private static SessionFactory sf;
	
	public static void main (String[] args) {
		sf = new Configuration().configure().buildSessionFactory();
		Session session = sf.openSession();
		
		HashSet children = new HashSet();
		children.add(new WorkOrder("FIRST"));
		children.add(new WorkOrder("SECOND"));
		children.add(new WorkOrder("THIRD"));
		
		OdissueTest ot = new OdissueTest();
		ot.addTicket("PARENT", "VF", children);
		
		ot.listTickets();
		
		
	}
	
	public void listTickets() {
		Session session = sf.openSession();
//		Transaction tx = null;
//		try {
//			tx = session.beginTransaction();
			List tickets = session.createQuery("FROM Ticket").list();
				for (Iterator it = tickets.iterator(); it.hasNext();) {
					Ticket tkt = (Ticket)it.next();
					System.out.println("ID: " + tkt.getId());
					System.out.println("Summary: " + tkt.getSummary());
					System.out.println("Requester: " + tkt.getRequester());
					
					Set wos = tkt.getWorkorders();
					for (Iterator it2 = wos.iterator(); it2.hasNext();) {
						WorkOrder wo = (WorkOrder)it2.next();
						System.out.println("Child WO: " + wo.getId() + wo.getParent() + wo.getSummary()); 
					}
				}
//			tx.commit();
//		} catch (HibernateException he) {
//			if (tx!=null) tx.rollback();		
//			he.printStackTrace();
//		} finally {
//			session.close();
//		}
	}
	
	public Integer addTicket(String summary, String requester, Set children) {
		Session session = sf.openSession();
		Integer ticketID = null;
		Transaction tx = null;
		try {
			tx = session.beginTransaction();
			Ticket tkt = new Ticket(summary, requester);
			tkt.setWorkorders(children);
			
			ticketID = (Integer)session.save(tkt);
			tx.commit();
		} catch (HibernateException he) {
			if (tx!=null) tx.rollback();
				he.printStackTrace();
		} finally {
			session.close();
		}
		return ticketID;
	}
	
	public void updateTicket(Integer TicketID, String summary) {
		Session session = sf.openSession();
		Transaction tx = null;
		try {
			tx = session.beginTransaction();
				Ticket tkt = (Ticket)session.get(Ticket.class, TicketID);
				tkt.setSummary(summary);
				session.update(tkt);
			tx.commit();
		} catch (HibernateException he) {
			if(tx!=null) tx.rollback();
			he.printStackTrace();
		} finally {
			session.close();
		}	
	}
	
	public void deleteTicket(Integer TicketID) {
		Session session = sf.openSession();
		Transaction tx = null;
		try {
			tx =  session.beginTransaction();
				Ticket tkt = (Ticket)session.get(Ticket.class, TicketID);
				session.delete(tkt);
				tx.commit();
		} catch (HibernateException he) {
			if(tx!=null) tx.rollback();
			he.printStackTrace();
		} finally {
			session.close();
		}
	}
}
