package com.odissue.hibernate.components;


import java.util.*;

import org.hibernate.HibernateException;
import org.hibernate.SQLQuery;
import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.Transaction;
import org.hibernate.cfg.Configuration;

import com.odissue.hibernate.components.WorkOrder;
import com.odissue.hibernate.components.OdissueTest;
import com.odissue.hibernate.components.Ticket;

public class OdissueTest {
	
	private static SessionFactory sf;
	
	public static void main (String[] args) {
		sf = new Configuration().configure().buildSessionFactory();
		Session session = sf.openSession();
		
		OdissueTest ot = new OdissueTest();
		
		WorkOrder wo = new WorkOrder("Component WO");
		ot.addTicket("Ticket with component WO", "VF", wo);
		
		ot.listTickets();		
		
	}
	
	public void listTickets() {
		Session session = sf.openSession();
//		Transaction tx = null;
//		try {
//			tx = session.beginTransaction();
			List tickets = session.createQuery("FROM Ticket").list();
				for (Iterator it = tickets.iterator(); it.hasNext();) {
					Ticket tkt = (Ticket)it.next();
					System.out.println("ID: " + tkt.getId());
					System.out.println("Summary: " + tkt.getSummary());
					System.out.println("Requester: " + tkt.getRequester());
					
					System.out.println("Child WO: " + tkt.getWorkorder().getSummary()); 
					}
//			tx.commit();
//		} catch (HibernateException he) {
//			if (tx!=null) tx.rollback();		
//			he.printStackTrace();
//		} finally {
//			session.close();
//		}
	}
	
	public Integer addTicket(String summary, String requester, WorkOrder wo) {
		Session session = sf.openSession();
		Integer ticketID = null;
		Transaction tx = null;
		try {
			tx = session.beginTransaction();
			Ticket tkt = new Ticket(summary, requester, wo);
			
			ticketID = (Integer)session.save(tkt);
			tx.commit();
		} catch (HibernateException he) {
			if (tx!=null) tx.rollback();
				he.printStackTrace();
		} finally {
			session.close();
		}
		return ticketID;
	}
		
	public void updateTicket(Integer TicketID, String summary) {
		Session session = sf.openSession();
		Transaction tx = null;
		try {
			tx = session.beginTransaction();
				Ticket tkt = (Ticket)session.get(Ticket.class, TicketID);
				tkt.setSummary(summary);
				session.update(tkt);
			tx.commit();
		} catch (HibernateException he) {
			if(tx!=null) tx.rollback();
			he.printStackTrace();
		} finally {
			session.close();
		}	
	}
	
	public void deleteTicket(Integer TicketID) {
		Session session = sf.openSession();
		Transaction tx = null;
		try {
			tx =  session.beginTransaction();
				Ticket tkt = (Ticket)session.get(Ticket.class, TicketID);
				session.delete(tkt);
				tx.commit();
		} catch (HibernateException he) {
			if(tx!=null) tx.rollback();
			he.printStackTrace();
		} finally {
			session.close();
		}
	}
}
