package com.odissue.mvc.service;

import java.util.*;

import org.hibernate.HibernateException;
import org.hibernate.SQLQuery;
import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.Transaction;
import org.hibernate.cfg.Configuration;

import com.odissue.mvc.model.Ticket;


public class PersistenceService {
	
	private static SessionFactory sf = new Configuration().configure().buildSessionFactory();

	
	public Integer addTicket(String summary, String requester) {
		Ticket tkt = null;
		Session session = sf.openSession();
		Transaction tx = null;
		try {
			tx = session.beginTransaction();
			tkt = new Ticket(summary, requester);
			session.save(tkt);
		tx.commit();
	} catch (HibernateException he) {
		if(tx!=null) tx.rollback();
		he.printStackTrace();
	} finally {
		session.close();
	}
		return tkt.getId(); // returns id for redirect
}
	
	public Integer addWorkOrder(String summary, String requester) {
		Ticket tkt = null;
		Session session = sf.openSession();
		Transaction tx = null;
		try {
			tx = session.beginTransaction();
			tkt = new Ticket("[wo] " + summary, requester);
			session.save(tkt);
		tx.commit();
	} catch (HibernateException he) {
		if(tx!=null) tx.rollback();
		he.printStackTrace();
	} finally {
		session.close();
	}
		return tkt.getId(); // returns id for redirect
}
	
	public void updateTicket(Integer TicketID, String assignee) {
		Session session = sf.openSession();
		Transaction tx = null;
		try {
			tx = session.beginTransaction();
				Ticket tkt = (Ticket)session.get(Ticket.class, TicketID);
				tkt.setAssignee(assignee);
				session.update(tkt);
			tx.commit();
		} catch (HibernateException he) {
			if(tx!=null) tx.rollback();
			he.printStackTrace();
		} finally {
			session.close();
		}	
	}
	
	public void deleteTicket(Integer TicketID) {
		Session session = sf.openSession();
		Transaction tx = null;
		try {
			tx =  session.beginTransaction();
				Ticket tkt = (Ticket)session.get(Ticket.class, TicketID);
				session.delete(tkt);
				tx.commit();
		} catch (HibernateException he) {
			if(tx!=null) tx.rollback();
			he.printStackTrace();
		} finally {
			session.close();
		}
	}
}
