package com.odissue.hibernate;

import java.util.*;

import org.hibernate.HibernateException;
import org.hibernate.SQLQuery;
import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.Transaction;
import org.hibernate.cfg.Configuration;

public class OdissueTest {
	
	private static SessionFactory sf;
	
	public static void main (String[] args) {
		sf = new Configuration().configure().buildSessionFactory();
		Session session = sf.openSession();
		System.out.println("test");
		
		System.out.println("Get connected? - " + session.isConnected());
//		SQLQuery query = session.createSQLQuery("SELECT * FROM ticket where id = 13");
//		System.out.println(query.list().get(0));
		
		System.out.println("Closing...");
		session.close();
		System.out.println("Get connected? - " + session.isConnected());
		
		OdissueTest ot = new OdissueTest();
		
		Integer tkt7 = ot.addTicket("New Hibernate ticket-1", "Vladimir Frolov");
		Integer tkt8 = ot.addTicket("New Hibernate ticket-2", "Vladimir Frolov");
		ot.listTickets();

		ot.updateTicket(tkt7, "Updated New Hibernate ticket-1");
		ot.deleteTicket(tkt8);
		ot.listTickets();

	}
	
	public void listTickets() {
		Session session = sf.openSession();
//		Transaction tx = null;
//		try {
//			tx = session.beginTransaction();
			List tickets = session.createQuery("FROM Ticket").list();
				for (Iterator it = tickets.iterator(); it.hasNext();) {
					Ticket tkt = (Ticket)it.next();
					System.out.println("ID: " + tkt.getId());
					System.out.println("Summary: " + tkt.getSummary());
					System.out.println("Requester: " + tkt.getRequester());
				}
//			tx.commit();
//		} catch (HibernateException he) {
//			if (tx!=null) tx.rollback();
//			he.printStackTrace();
//		} finally {
//			session.close();
//		}
	}
	
	public Integer addTicket(String summary, String requester) {
		Session session = sf.openSession();
		Integer ticketID = null;
		Transaction tx = null;
		try {
			tx = session.beginTransaction();
			Ticket tkt = new Ticket(summary, requester);
			ticketID = (Integer)session.save(tkt);
			tx.commit();
		} catch (HibernateException he) {
			if (tx!=null) tx.rollback();
				he.printStackTrace();
		} finally {
			session.close();
		}
		return ticketID;
	}
	
	public void updateTicket(Integer TicketID, String summary) {
		Session session = sf.openSession();
		Transaction tx = null;
		try {
			tx = session.beginTransaction();
				Ticket tkt = (Ticket)session.get(Ticket.class, TicketID);
				tkt.setSummary(summary);
				session.update(tkt);
			tx.commit();
		} catch (HibernateException he) {
			if(tx!=null) tx.rollback();
			he.printStackTrace();
		} finally {
			session.close();
		}	
	}
	
	public void deleteTicket(Integer TicketID) {
		Session session = sf.openSession();
		Transaction tx = null;
		try {
			tx =  session.beginTransaction();
				Ticket tkt = (Ticket)session.get(Ticket.class, TicketID);
				session.delete(tkt);
				tx.commit();
		} catch (HibernateException he) {
			if(tx!=null) tx.rollback();
			he.printStackTrace();
		} finally {
			session.close();
		}
	}
}
