package src;

import java.beans.*;
import java.io.Serializable;

public class WorkOrder implements PropertyChangeListener, Serializable {
	
	private String summary;
	private String status;
	
	private PropertyChangeSupport pcs = new PropertyChangeSupport(this);	
	
	public WorkOrder() {
		pcs.addPropertyChangeListener(this);
	}
	
	public void propertyChange(PropertyChangeEvent evt) {
		System.out.println("Name: " + evt.getPropertyName());
		System.out.println("Old val: " + evt.getOldValue());
		System.out.println("New val: " + evt.getNewValue());
	}
			
	public String getStatus() {
		return status;
	}
	
	public void setStatus(String status) {
		String oldValue = this.status;
		this.status = status;
		pcs.firePropertyChange("status", oldValue, status);
	}
	
	public String getSummary() {
		return summary;
	}
	
	public void setSummary(String summary) {
		this.summary = summary;
	}
	
	public void addPropertyChangeListener(PropertyChangeListener listener) {
		pcs.addPropertyChangeListener(listener);
	}
	
	public void removePropertyChangeListener(PropertyChangeListener listener) {
		pcs.removePropertyChangeListener(listener);
	}
}
