import java.sql.*;


public class PlayBatch {
	
	public static void batchUp() throws SQLException {
		
		Connection conn = DriverManager.getConnection("jdbc:mysql://localhost:3306/testdb?user=root&password=toor");
		Statement stmt = conn.createStatement();
		
		conn.setAutoCommit(false);
		stmt.addBatch("INSERT INTO tea VALUES ('Indian Spice', 'Black', 10.99)");
		stmt.addBatch("INSERT INTO tea VALUES ('Puer', 'Black', 10.99)");
		
		int[] upCount = stmt.executeBatch();
		conn.commit();
		
		for(int i = 0; i <= upCount.length-1; i++) {
			System.out.println(upCount[i]);
		}
	}
	
	
/*	Parameterized Batch Update */
	public static void batchUpParams() throws SQLException {
		
		Connection conn = DriverManager.getConnection("jdbc:mysql://localhost:3306/testdb?user=root&password=toor");
		PreparedStatement pstmt = conn.prepareStatement("INSERT INTO tea VALUES (?, ?, ?)");
		
		conn.setAutoCommit(false);
		pstmt.setString(1, "English Breakfast");
		pstmt.setString(2, "Black");
		pstmt.setDouble(3, 10.99);
		pstmt.addBatch();
		
		pstmt.setString(1, "Camomile");
		pstmt.setString(2, "Green");
		pstmt.setDouble(3, 9.99);
		pstmt.addBatch();
		
		int[] upCount = pstmt.executeBatch();
		conn.commit();
		
		for(int i = 0; i <= upCount.length-1; i++) {
			System.out.println("Updated: " + upCount[i]);
		}
	}
	
	public static void main(String[] args) throws SQLException {
		batchUp();
		batchUpParams();
	}

}
