import java.sql.*;

import javax.sql.rowset.JdbcRowSet;
import javax.sql.rowset.RowSetFactory;
import javax.sql.rowset.RowSetProvider;

public class PlayJdbcRowSetObject {
	
	public static void risePrices(JdbcRowSet jrs, int percent) throws SQLException {
		
		while(jrs.next()) {
			jrs.updateDouble(3, jrs.getDouble(3) + (jrs.getDouble(3) / 100 * percent));
			jrs.updateRow();
		} 
	}
	
	public static void insertCoffee(JdbcRowSet jrs, String cofName, int supId, double price, int sales, int total) 
		throws SQLException {
		
		jrs.moveToInsertRow();
		jrs.updateString("COF_NAME", cofName);
		jrs.updateInt("SUP_ID", supId);
		jrs.updateDouble("PRICE", price);
		jrs.updateInt("SALES", sales);
		jrs.updateInt("TOTAL", total);
		jrs.insertRow();
	}
	
	public static void rmCoffee(JdbcRowSet jrs, String name) throws SQLException {
		
		jrs.beforeFirst();
		
		while(jrs.next()) {
			if(jrs.getString("COF_NAME").equals(name)) {
				jrs.deleteRow();
			}
		}		
	}
		
	public static JdbcRowSet doConnect() throws SQLException {
		
		RowSetFactory RSFactory = RowSetProvider.newFactory();
		JdbcRowSet jrs = RSFactory.createJdbcRowSet();
		
		jrs.setUrl("jdbc:mysql://localhost:3306/testdb");
		jrs.setUsername("root");
		jrs.setPassword("toor");
		
		jrs.setCommand("SELECT * FROM coffees");
		jrs.execute();
		
		return jrs;
				
	}
	
	public static void main(String[] args) throws SQLException {
		
		JdbcRowSet jrs = doConnect();
		
		risePrices(jrs, 10);
		
		insertCoffee(jrs, "Macciato", 101, 199.99, 12, 29);
						
		jrs.absolute(2);
		jrs.updateDouble(3, 88.99);
		jrs.updateRow();
		
		jrs.beforeFirst();
		
		while(jrs.next()) {
			System.out.println(jrs.getString(3));
		}
		
		rmCoffee(jrs, "Macciato");
	}
}