import java.sql.*;
import java.util.ArrayList;
import java.util.Iterator;

import javax.sql.rowset.*;

public class PlayCachedRowSetListener {
	
	public static void doConnect() throws SQLException {
		
		// instantiate listener object and set default message
		PlayListener pl = new PlayListener();
		pl.setMessage("Can't hear you");
		
		Connection conn = DriverManager.getConnection("jdbc:mysql://localhost:3306/testdb?user=root&password=toor");
		conn.setAutoCommit(false);
		
		RowSetFactory rsf = RowSetProvider.newFactory();
		CachedRowSet crs = rsf.createCachedRowSet();
		
		int[] keys = {1};
		crs.setKeyColumns(keys);
		
		crs.setCommand("SELECT * FROM coffees");
		crs.execute(conn);
		
		crs.acceptChanges();
		
		crs.addRowSetListener(pl);
		
		// rowChanged event (inserting)
		crs.moveToInsertRow();
		crs.updateString("COF_NAME", "LISTENER");
		crs.updateInt("SUP_ID", 0);
		crs.updateDouble("PRICE", 0);
		crs.updateInt("SALES", 0);
		crs.updateInt("TOTAL", 0);
		crs.insertRow();
		crs.moveToCurrentRow();
		
		// cursorMoved event
		while(crs.next()) {
			System.out.println(crs.getString("COF_NAME"));

			// rowChanged event (deleting)			
			if(crs.getString("COF_NAME").equals("LISTENER")) {
				crs.deleteRow();
			}
		}	
		
		// showing listener messages
		for(Iterator it = pl.getMessage().iterator(); it.hasNext();) {
			System.out.println(it.next());
		}
			
	}
	
	public static void main(String[] args) throws SQLException {
		doConnect();
	}

}
