import java.sql.*;
import java.util.Random;

import javax.sql.rowset.*;

public class PlayInsertCachedRowSet {
		
	public static void doInsert() throws SQLException, InstantiationException, IllegalAccessException {
			
		Random index = Random.class.newInstance();
				
		Connection conn = DriverManager.getConnection("jdbc:mysql://localhost:3306/testdb?user=root&password=toor");
		conn.setAutoCommit(false);
		
		RowSetFactory rsf = RowSetProvider.newFactory();
		CachedRowSet crs = rsf.createCachedRowSet();
		
		int[] keys = {1};
		crs.setKeyColumns(keys);
		
		crs.setCommand("SELECT * FROM coffees");
		crs.execute(conn);
			
		crs.moveToInsertRow();
		crs.updateString("COF_NAME", "Macchiato" + index.nextInt(9));
		crs.updateInt("SUP_ID", 101);
		crs.updateDouble("PRICE", 99.9);
		crs.updateInt("SALES", 11);
		crs.updateInt("TOTAL", 34);
		crs.insertRow();
		crs.moveToCurrentRow();
		
		crs.acceptChanges(conn);
		
	}
	
	public static void doRemove(String cName) throws SQLException {
		
		Connection conn = DriverManager.getConnection("jdbc:mysql://localhost:3306/testdb?user=root&password=toor");
		conn.setAutoCommit(false);
		
		RowSetFactory rsf = RowSetProvider.newFactory();
		CachedRowSet crs = rsf.createCachedRowSet();
		
		int[] keys = {1};
		crs.setKeyColumns(keys);
		
		crs.setCommand("SELECT * FROM coffees");
		crs.execute(conn);

		while(crs.next()) {
			if(crs.getString("COF_NAME").equals(cName)) {
				crs.deleteRow();
				break;
			}
		}
		
		crs.acceptChanges(conn);		
	}
	
	public static void main(String[] args) throws SQLException, InstantiationException, IllegalAccessException {
		
		doInsert();
		doRemove("Macchiato3");
	}

}
