import java.sql.*;

import javax.sql.*;
import javax.sql.rowset.*;

public class PlayJoinRowSet {
	
	public static void doConnect() throws SQLException {
		
		Connection conn = DriverManager.getConnection("jdbc:mysql://localhost:3306/testdb?user=root&password=toor");
		conn.setAutoCommit(false);
		
		RowSetFactory rsf = RowSetProvider.newFactory();
		
		CachedRowSet coffees = rsf.createCachedRowSet();
		CachedRowSet suppliers = rsf.createCachedRowSet();
		CachedRowSet inventory = rsf.createCachedRowSet();
		JoinRowSet jrs = rsf.createJoinRowSet();
		
		coffees.setCommand("SELECT * FROM coffees");
		coffees.execute(conn);
		
		suppliers.setCommand("SELECT * FROM suppliers");
		suppliers.execute(conn);
		
		inventory.setCommand("SELECT * FROM merch_inventory");
		inventory.execute(conn);
		
		jrs.addRowSet(coffees, "SUP_ID");
		jrs.addRowSet(suppliers, "SUP_ID");
//		jrs.addRowSet(inventory, "SUP_ID");
				
		String sname = "Acme, Inc.";
		System.out.println("Coffees bought from " + sname + ": ");
		
		while(jrs.next()) {
			if(jrs.getString("SUP_NAME").equals(sname)) {
				String coffeeName = jrs.getString("COF_NAME");
				System.out.println(coffeeName);
			}
		}
		
	}
	
	public static void main(String[] args) throws SQLException {
		doConnect();
	}
}

