import java.io.*;
import java.sql.*;

public class PlayLargeObjects {
	
	
	private static String readFile(String fileName, Writer writerArg) throws FileNotFoundException, IOException {
		
		BufferedReader br = new BufferedReader(new FileReader(fileName));
		String nextLine = "";
		StringBuffer sb = new StringBuffer();
		
		while((nextLine = br.readLine()) != null) {
			System.out.println("Writing " + nextLine);
			writerArg.write(nextLine);
			sb.append(nextLine);
		}
		
		String clobData = sb.toString();
		return clobData;
		
	}
	
	
	public static void doConnect() throws SQLException, FileNotFoundException, IOException {
		
		Connection conn = DriverManager.getConnection("jdbc:mysql://localhost:3306/testdb?user=root&password=toor");
		
		/* Adding Large Object Type Object to Database */
		String fileName = "D:\\temp\\cdesc.txt";
		Clob myClob = conn.createClob();
		Writer clobWriter = myClob.setCharacterStream(1);
		String str = readFile(fileName, clobWriter);
		
		System.out.println("READS: " + str);
		
		myClob.setString(1, str);
		
		String sql = "INSERT INTO coffee_descriptions VALUES(?, ?)";
		
		PreparedStatement ps = conn.prepareStatement(sql);
		ps.setString(1, "Latte7");
		ps.setClob(2, myClob);
		ps.executeUpdate();
		
		/* Retrieving CLOB Values */
		PreparedStatement st = conn.prepareStatement("SELECT cof_desc FROM coffee_descriptions WHERE cof_name = 'Capuccino'");
		ResultSet rs = st.executeQuery();
		Clob myClob2 = null;
		
		if(rs.next()) {
            myClob2 = rs.getClob(1);
            System.out.println("Value of retrieved Clob: " +
                myClob2.getSubString(1, 11));

		}
	}
	
	public static void main(String[] args) throws FileNotFoundException, SQLException, IOException {
		
		doConnect();
	}
}
