import java.sql.*;


public class PlayProcedures {
	
	public static void createProcedure() throws SQLException {
		
		Connection conn = DriverManager.getConnection("jdbc:mysql://localhost:3306/testdb?user=root&password=toor");
		String createProcedure = 
				"CREATE PROCEDURE show_coffees() " +
				"BEGIN " +
					"SELECT COF_NAME FROM coffees; " +
				"END";
		
		Statement stmt = conn.createStatement();
		
		if (stmt.execute(createProcedure)) {
			System.out.println("Procedure created.");
		}		
	}
	
	public static void dropProcedure(String procedureName) throws SQLException {
		
		Connection conn = DriverManager.getConnection("jdbc:mysql://localhost:3306/testdb?user=root&password=toor");
		String dropProcedure = 
				"DROP PROCEDURE IF EXISTS " + procedureName + ";";
		
		Statement stmt = conn.createStatement();
		
		if (stmt.execute(dropProcedure)) {
			System.out.println("Procedure dropped.");
		}		
	}
	
	public static void callProcedure() throws SQLException {
		
		Connection conn = DriverManager.getConnection("jdbc:mysql://localhost:3306/testdb?user=root&password=toor");
		CallableStatement cstmt = conn.prepareCall("{call show_coffees()}");
		ResultSet rs = cstmt.executeQuery();
		
		while(rs.next()) {
			System.out.println(rs.getString(1));
		}
	}	
		
	
	public static void main (String[] args) throws SQLException {
		
		createProcedure();
		callProcedure();
		dropProcedure("show_coffees");
	}
}
