import java.sql.CallableStatement;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.sql.Statement;
import java.sql.Types;


public class PlayProceduresInInOut {
	
	public static void createProcedureInInOut() throws SQLException {
		
	Connection conn = DriverManager.getConnection("jdbc:mysql://localhost:3306/testdb?user=root&password=toor");
		
		String createProcedure = 
				 "create procedure RAISE_PRICE(" +
					        "IN coffeeName varchar(32), " +
					        "IN maximumPercentage float, " +
					        "INOUT newPrice numeric(10,2)) " +
					        "begin " +
					        "main: BEGIN " +
					            "declare maximumNewPrice " +
					                "numeric(10,2); " +
					            "declare oldPrice numeric(10,2); " +
					            "select COFFEES.PRICE into oldPrice " +
					                "from COFFEES " +
					                "where COFFEES.COF_NAME " +
					                "= coffeeName; " +
					            "set maximumNewPrice = " +
					                "oldPrice * (1 + " +
					                "maximumPercentage); " +
					            "if (newPrice > maximumNewPrice) " +
					                "then set newPrice = " +
					                "maximumNewPrice; " +
					            "end if; " +
					            "if (newPrice <= oldPrice) " +
					                "then set newPrice = oldPrice; " +
					                "leave main; " +
					            "end if; " +
					            "update COFFEES " +
					                "set COFFEES.PRICE = newPrice " +
					                "where COFFEES.COF_NAME " +
					                "= coffeeName; " +
					            "select newPrice; " +
					        "END main; " +
					        "end";
				
		
		Statement stmt = conn.createStatement();
		
		if (stmt.execute(createProcedure)) {
			System.out.println("Procedure created.");
		}	
	}
	

	public static void callProcedureInInOut(String coffeeNameArg, float maxPercentArg, float newPriceArg) throws SQLException {
		
		Connection conn = DriverManager.getConnection("jdbc:mysql://localhost:3306/testdb?user=root&password=toor");
		CallableStatement cstmt = conn.prepareCall("{call RAISE_PRICE(?, ?, ?)}");
		cstmt.setString(1, coffeeNameArg);
		cstmt.setFloat(2, maxPercentArg);
		cstmt.registerOutParameter(3, Types.NUMERIC);
		cstmt.setFloat(3, newPriceArg);
		cstmt.execute();
		
		float price = cstmt.getFloat(3);
		
		System.out.println("New price is: " + price);
		
	}	
	

	public static void main (String[] args) throws SQLException {
		
//		createProcedureInInOut();
		callProcedureInInOut("Latte", 10, 220);
	}
}
