import java.sql.CallableStatement;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.sql.Statement;
import java.sql.Types;


public class PlayProceduresInOut {
	
	public static void createProcedureInOut() throws SQLException {
		
	Connection conn = DriverManager.getConnection("jdbc:mysql://localhost:3306/testdb?user=root&password=toor");
		
		String createProcedure = 
				"CREATE PROCEDURE get_supplier_of_coffee(" +
				"IN coffeeName varchar(32), OUT supplierName varchar(40)) " +
				"BEGIN " +
					"SELECT suppliers.sup_name INTO supplierName " +
					"FROM suppliers, coffees WHERE suppliers.sup_id = coffees.sup_id " +
					"AND coffeeName = coffees.cof_name; " +
					"select supplierName; " +
				"END";
		
		Statement stmt = conn.createStatement();
		
		if (stmt.execute(createProcedure)) {
			System.out.println("Procedure created.");
		}	
	}
	

	public static void callProcedureInOut(String coffeNameArg) throws SQLException {
		
		Connection conn = DriverManager.getConnection("jdbc:mysql://localhost:3306/testdb?user=root&password=toor");
		CallableStatement cstmt = conn.prepareCall("{call get_supplier_of_coffee(?, ?)}");
		cstmt.setString(1, coffeNameArg);
		cstmt.registerOutParameter(2, Types.CHAR);
		cstmt.executeQuery();
		
		String supplierName = cstmt.getString(2);
		
		System.out.println("Supplier name for " + coffeNameArg + " is: " + supplierName);
	}	
	

	public static void main (String[] args) throws SQLException {
		
		callProcedureInOut("Latte");
	}
}
