package april19;

import java.util.Date;
import java.util.GregorianCalendar;

public class Employee {
	
	private String name;
	private double salary;
	private Date hireDay;
	
	public static int nextId = 1;
	private int id;
	
	public Employee (String n, double s, int year, int month, int day) {
		name = n;
		salary = s;
		GregorianCalendar calendar = new GregorianCalendar(year, month - 1, day);
		hireDay = calendar.getTime();		
	}
	
	public Employee (String n, double s) {
		name = n;
		salary = s;
		id = 0;
		
	}
	
	public String getName() {
		return name;
	}
	
	public double getSalary() {
		return salary;
	}
	
	public Date getHireDay() {
		return hireDay;
	}
	
	public void raiseSalary (double byPercent) {
		double raise = salary * byPercent / 100;
		salary += raise;
	}
	
	public int getId() {
		return id;
	}
	
	public void setId() {
		id = nextId;
		nextId++;
	}
	
	public static int getNextId() {
		return nextId;
	}
	
	
	public static void main (String[] args) {			// unit test
		Employee e = new Employee ("Jacob", 50000);
		System.out.println(e.getName() + " " + e.getSalary());
		
		
	}
	
	
}