package april26;

import java.util.Date;
import java.util.GregorianCalendar;

public class ManagerTest {

	public static void main(String[] args) {

		Manager boss = new Manager("Manager", 100000, 1987, 12, 9);
		boss.setBonus(51000);

		Executive exec = new Executive ("CEO", 100000, 1985, 11, 11);

		Employee[] staff = new Employee[4];

		staff[0] = boss;
		staff[1] = exec;
		staff[2] = new Employee("Employee1", 40000, 2000, 12, 12);
		staff[3] = new Employee("Employee2", 30000, 2002, 12, 12);

		for (Employee e : staff) {
			System.out.println("Name = " + e.getName() + "Salary = "
					+ e.getSalary());

		}

	}

}

class Employee {

	private String name;
	private double salary;
	private Date hireDay;

	public Employee(String n, double s, int year, int month, int day) {

		name = n;
		salary = s;
		GregorianCalendar calendar = new GregorianCalendar(year, month - 1, day);
		hireDay = calendar.getTime();
	}

	public String getName() {
		return name;
	}

	public double getSalary() {
		return salary;
	}

	public Date getHireDay() {
		return hireDay;
	}

	public void raiseSalary(double byPercent) {
		double raise = salary * byPercent / 100;
		salary += raise;

	}

}

class Manager extends Employee {

	private double bonus;

	public Manager(String n, double s, int year, int month, int day) {
		super(n, s, year, month, day);
		bonus = 0;
	}

	public double getSalary() {

		double baseSalary = super.getSalary();
		return baseSalary + bonus;
	}

	public void setBonus(double b) {
		bonus = b;
	}

}


class Executive extends Manager {

	public int stocks;

	public Executive(String n, double s, int year, int month, int day) {
		super(n, s, year, month, day);		
		stocks = (int)this.getHireDay().getTime() * 10 / 10000;
	}

	public double getSalary() {
		double baseSalary = super.getSalary();
		double execSalary = baseSalary + stocks * 10;
		return execSalary;		
	}

}