package april26;

import java.util.Date;
import java.util.GregorianCalendar;


public class PersonTest {

	public static void main (String[] args) {

		Person[] people = new Person[2];
		people[0] = new Employee2("Harry Harrison", 50000, 1989, 10, 1, 55);
		people[1] = new Student("Isaac Newton", "math", 28);

		for (Person p : people) {
			System.out.println(p.getName() + ",  " + p.getDescription() + ", " + p.getAge());
		}

	}	

}


abstract class Person {
	private String name;
	private int age;

	public Person (String n, int a) {

		name = n;
		age = a;

	}

	public abstract String getDescription();
	public abstract int getAge();

	public String getName() {
		return name;
	}

}


class Employee2 extends Person {

	private double salary;
	private Date hireDay;
	private int age;

	public Employee2 (String n, double s, int year, int month, int day, int a) {

		super(n, a);
		age = a;
		salary = s;

		GregorianCalendar calendar = new GregorianCalendar(year, month-1, day);
		hireDay = calendar.getTime();
	}

	public double getSalary() {
		return salary;
	}

	public Date getHireDate() {
		return hireDay;		
	}

	public void raiseSalary(double byPercent) {
		double raise = salary * byPercent / 100;
		salary += raise;	
	}

	public String getDescription() {
		return String.format("an employee with a salary of $%.2f", salary);

	}

	public int getAge() {
		return age;		
	}
}


class Student extends Person {

	private String major;
	private int age;

	public Student (String n, String m, int a) {
		super(n, a);
		age = a;
		major = m;
	}

	public String getDescription() {
		return "a student majoring in " + major;
	}

	public int getAge() {
		return age;
	}
}