package may3;

import java.util.Arrays;

public class EmployeeSortTest {

	public static void main(String[] args) {

		Employee[] staff = new Employee[3];

		staff[0] = new Employee("Jack", 160000);
		staff[1] = new Employee("Peter", 120000);
		staff[2] = new Employee("Bob", 150000);

		Arrays.sort(staff);
		System.out.println(staff[0].compareTo(staff[1]));

		for (Employee e : staff) {

			System.out.println(e.getName() + " = " + e.getSalary());
		}

	}

}

class Employee implements Comparable<Employee> {

	private String name;
	private double salary;

	public Employee(String n, double s) {
		name = n;
		salary = s;
	}

	public String getName() {

		return name;

	}

	public double getSalary() {

		return salary;

	}

	public void raiseSalary(double byPercent) {

		double raise = salary * byPercent / 100;
		salary += raise;
	}

	public int compareTo(Employee other) {
		if (salary < other.salary)
			return -1;
		if (salary > other.salary)
			return 1;
		return 0;
	}

}