import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.util.*;

import tickets.Incident;


public class ClassRetriever {
	
	enum Enumeration {A, B, C, D, E, F, G}

	public static void main(String[] args) throws InstantiationException, IllegalAccessException, 
		ClassNotFoundException, NoSuchFieldException, SecurityException, NoSuchMethodException {
		
		Class c = "hello".getClass();
		System.out.println(c.getSimpleName());
		
//		Class c2 = System.console().getClass();
		
		Class c3 = Enumeration.A.getClass();
		Object[] consts = c3.getEnumConstants();
		
		for (int i = 0; i < consts.length; i++) {
			System.out.println(consts[i]);
		}
		
		Set<String> s = new HashSet<String>();
		s.add("Analysis");
		s.add("Data Visualization");
		s.add("Reporting");
		
		Class c4 = s.getClass();
		
		Set s2 = s.getClass().newInstance();
		s2.add(s);
		
		for(Iterator it = s2.iterator(); it.hasNext();) {
			System.out.println(it.next());
		}
		
		// obtain the Class for a primitive type
		Class c5 = boolean.class;
		
		
		// Class.forName()
		Class c6 = Class.forName("tickets.Ticket");
		Class c7 = Class.forName("java.lang.String");
		System.out.println(c6.getSimpleName());
		
		
		// TYPE Field for Primitive Type Wrappers
		Class c8 = Double.TYPE;
		Class c9 = Void.TYPE;
		System.out.println(c9.getSimpleName());
		
		// Methods that Return Classes
		Class c10 = java.beans.PropertyChangeSupport.class.getSuperclass();
		Class c11 = tickets.WorkOrder.class.getSuperclass();
		System.out.println(c10.getSimpleName() + c11.getSimpleName());
		
		
		Class c33 = Class.forName("ticket.class.person");
		Class c44 = Class.forName("java.lang.Concurrency.ticket.overlay");
		Class<?>[] c12 = Character.class.getClasses();
		Class<?>[] c13 = java.util.concurrent.ConcurrentHashMap.class.getDeclaredClasses();
		for(int i = 0; i < c13.length; i++) {
			System.out.println("Class:" + c13[i].getSimpleName());
		}
		
		
		Method f = tickets.Ticket.class.getMethod("getId");
		Class c14 = f.getDeclaringClass();
		System.out.println("\nDeclared in: " + c14.getSimpleName());
		
	}
}
