import java.lang.annotation.Annotation;
import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Type;


public class ConstructorMembers {
	
	public static void main (String[] args) throws ClassNotFoundException, InstantiationException, IllegalAccessException, IllegalArgumentException, InvocationTargetException {
		
		Class c = Class.forName("Ticket");
		Constructor[] constructors = c.getDeclaredConstructors();
		
		for (Constructor ctr : constructors) {

			System.out.println("Constructor: " + ctr.toGenericString());

			Type[] types = ctr.getGenericParameterTypes();
			
			for (Type t : types) {
				System.out.println("Parameter: " + t.toString());
			}
			
			Annotation[] anns = ctr.getAnnotations();
			
			for (Annotation a : anns) {
				System.out.println("Annotation: " + a.toString());
			}
		}
		
		Ticket t = (Ticket) constructors[1].newInstance("Object #", 3012);
		System.out.println(t.getSummary() + t.getId());		
		
	}

}
