import java.lang.reflect.*;

public class MethodMembers {
	
	public static void main(String[] args) throws ClassNotFoundException, 
		IllegalAccessException, IllegalArgumentException, InvocationTargetException {
		
		Class c = Class.forName("Ticket");
		Method[] allMethods = c.getDeclaredMethods();
		
		System.out.println("Method analytics:\n");		
		for (Method m : allMethods) {
			
			Class[] pType = m.getParameterTypes();
			for (int i = 0; i < pType.length; i++) {
				System.out.println("\nparameters: " + pType[i]);
			}
			
			System.out.println("method: " + m.toGenericString()
					+ "\nreturn: " + m.getGenericReturnType() 
					+ "\nmodifiers: " + Modifier.toString(m.getModifiers()) + "\n");
			}
		
		Ticket t = new Ticket();
		Class c2 = t.getClass();
		Method[] tMethods = c2.getDeclaredMethods();
		
		tMethods[1].invoke(t, "AV on saving user profile");	// t.setSummary()
		System.out.println(tMethods[0].invoke(t, null));	// t.getSummary()
		
		
		String[] args2 = {"Summary1", "Summary2", "Summary3"};
		tMethods[4].invoke(t, args2);

		System.out.println(tMethods[0].invoke(t, null));

			
	}

}
