package odissue72.value;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.beans.factory.annotation.Value;

public class Ticket {
	
	// simple dynamic values autowired with SpEL
	@Value("wo's bean summary - #{wo.summary}")
	private String summary;
	
	// wiring simple values
	@Value("11111")
	private int id;
	
	@Autowired
	@Qualifier("person")
	private Person assignee;
	
	@Autowired(required=false)
	@Qualifier("wo2")
	private WorkOrder wo;

	public Ticket() {
		
	}
	
	public Ticket(String s, Person a, int i) {
		this.summary = s;
		this.assignee = a;
		this.id = i;
	}
	
	public String getSummary() {
		return summary;
	}
	public void setSummary(String summary) {
		this.summary = summary;
	}
	public Person getAssignee() {
		return assignee;
	}
	public void setCustomAssignee(Person assignee) {
		this.assignee = assignee;
	}
	public int getId() {
		return id;
	}
	public void setId(int id) {
		this.id = id;
	}

	public WorkOrder getWo() {
		return wo;
	}
	
	public void setWo(WorkOrder wo) {
		this.wo = wo;
	}
}
