package odissue73.jdbc;

import java.sql.ResultSet;
import java.sql.SQLException;

import org.springframework.context.ApplicationContext;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.simple.ParameterizedRowMapper;

public class PersonDAO extends BaseDAO {	// extends custom base DAO class for reducing template setters
	
	private static String SQL_CREATE_PERSON = "INSERT INTO person VALUES (?, ?, ?)";
	private static String SQL_SELECT_PERSON = "SELECT name, department, id FROM summary WHERE id = ?";
	
	public void createPerson(Person prsn) {		
		super.getTemplate().update(SQL_CREATE_PERSON, prsn.getName(), prsn.getDepartment(), prsn.getId());
		System.out.println("PERSON CREATED");
	}
	
	public Person getPersonById(int id) {
		return super.getTemplate().queryForObject(SQL_SELECT_PERSON,
				new ParameterizedRowMapper<Person>() {
			public Person mapRow(ResultSet rs, int rowNum) throws SQLException {
				Person prsn = new Person();
				prsn.setName(rs.getString(1));
				prsn.setDepartment(rs.getString(2));
				prsn.setId(rs.getInt(3));
				return prsn;
			}
		}, id);
	}

}
