package odissue73.jdbc;

import java.sql.ResultSet;
import java.sql.SQLException;

import org.springframework.context.ApplicationContext;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.simple.ParameterizedRowMapper;
import org.springframework.jdbc.core.support.JdbcDaoSupport;

//public class TicketDAO extends BaseDAO {
public class TicketSupportDAO extends JdbcDaoSupport {		// extends Spring's base template class
	
	private static String SQL_CREATE_TICKET = "INSERT INTO ticket VALUES (?, ?, ?)";
	private static String SQL_SELECT_TICKET = "SELECT summary, requester, id FROM ticket WHERE id = ?";
	
	public void createTicket(Ticket tkt) {		
		getJdbcTemplate().update(SQL_CREATE_TICKET, tkt.getSummary(), tkt.getRequester(), tkt.getId());
		System.out.println("TICKET CREATED");
	}
	
	public Ticket getTicketById(int id) {
		return getJdbcTemplate().queryForObject(SQL_SELECT_TICKET,
				new ParameterizedRowMapper<Ticket>() {
			public Ticket mapRow(ResultSet rs, int rowNum) throws SQLException {
				Ticket ticket = new Ticket();
				ticket.setSummary(rs.getString(1));
				ticket.setRequester(rs.getString(2));
				ticket.setId(rs.getInt(3));
				return ticket;
			}
		}, id);
	}

}
