package com.odissue.basic;

import java.util.ArrayList;
import java.util.List;

import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;

@Controller
@RequestMapping("/issues")
public class IssueController {
	
	public List<Ticket> getTickets() {

		ApplicationContext ctx = new ClassPathXmlApplicationContext("com/odissue/basic/odissue-beans.xml");
		
		List<Ticket> tickets = new ArrayList<Ticket>();
		tickets.add((Ticket)ctx.getBean("incident"));
		tickets.add((Ticket)ctx.getBean("workorder"));
		tickets.add((Ticket)ctx.getBean("workorder2"));
		tickets.add((Ticket)ctx.getBean("incident2"));
		
		return tickets;
		
	}
	
	@RequestMapping(value="/ticket", method=RequestMethod.GET)
	public String listTicketsById(@RequestParam("id")int id, Model model) {
		model.addAttribute("id", id);
		model.addAttribute("tickets", getTickets());
		return "tickets/getById";
	}
	
	@RequestMapping("/")
	public String listTickets(Model model) {
		model.addAttribute("tickets", getTickets());
		return "tickets/list";
		
	}
	
}
